//
// vmware-vmx hook injector application
// Copyright (C) 2007 Ken Johnson (Skywing)
// http://www.nynaeve.net
// skywing@valhallalegends.com
//
// This program injects vmxhook.dll into vmware-vmx.exe.
//

#include <string.h>
#include <stdlib.h>
#include <windows.h>
#include <strsafe.h>
#include <io.h>

BOOLEAN
InjectVmxPatch(
	__in HANDLE Process,
	__in CONST CHAR *DllName
	)
{
	PVOID  _LoadLibraryA;
	PVOID  _FreeLibrary;
	PVOID  _ExitThread;
	char   Code[ 512 ];
	SIZE_T Written;
	PVOID  Buf;
	HANDLE Thread;

	/*
	 * Based off of Andreas Hansson's remotehdl - for sake of small code.
	 */

	memcpy(
		Code + 256,
		"\xe8\x00\x00\x00\x00\x58\x2d\x05\x01\x00\x00\x50\xb8\x00\x00\x00\x00\xff\xd0\x6a\x00\xb8\x00\x00\x00\x00\xff\xd0",
		28
		);
	*(DWORD_PTR*)(Code + 256 + 13) = (DWORD_PTR)LoadLibraryA;
	*(DWORD_PTR*)(Code + 256 + 22) = (DWORD_PTR)ExitThread;

	StringCbCopyA(
		Code,
		256,
		DllName
		);

	Buf = VirtualAllocEx(
		Process,
		0,
		4096,
		MEM_COMMIT,
		PAGE_EXECUTE_READWRITE
		);

	if (!Buf)
	{
		wprintf(L"Couldn't allocate memory (%lu).\n",
			GetLastError());
		return FALSE;
	}

	if (!WriteProcessMemory(
		Process,
		Buf,
		Code,
		sizeof( Code ),
		&Written))
	{
		wprintf(L"Couldn't write process memory (%lu).\n",
			GetLastError());

		return FALSE;
	}

	Thread = CreateRemoteThread(
		Process,
		0,
		0,
		(LPTHREAD_START_ROUTINE)((PUCHAR)Buf + 256),
		0,
		0,
		0
		);

	if (!Thread)
	{
		wprintf(L"Couldn't create thread (%lu).\n",
			GetLastError());

		VirtualFreeEx(
			Process,
			Buf,
			0,
			MEM_RELEASE
			);

		return FALSE;
	}

	WaitForSingleObject(
		Thread,
		INFINITE
		);

	CloseHandle(
		Thread
		);

	VirtualFreeEx(
		Process,
		Buf,
		0,
		MEM_RELEASE
		);

	return TRUE;
}

int
__cdecl
main(
	int ac,
	char **av
	)
{
	HANDLE  Process;
	CHAR    VmxPatchDll[ 256 ];
	BOOLEAN Success;

	if (ac != 2)
	{
		wprintf(L"Usage: %S <vmware-vmx-pid>\n",
			av[0]);

		return 1;
	}

	if (!GetCurrentDirectoryA(
		256,
		VmxPatchDll))
	{
		wprintf(L"Couldn't determine current directory (%lu).\n",
			GetLastError());

		return 1;
	}

	if (FAILED(StringCbCatA(
		VmxPatchDll,
		sizeof( VmxPatchDll ),
		"\\vmxpatch.dll")))
	{
		wprintf(L"Current directory pathname exceeded limits.\n");
		return 1;
	}

	if (_access(
		VmxPatchDll,
		00))
	{
		wprintf(L"VmxPatch.dll must be contained in the current directory.\n -> %S\n",
			VmxPatchDll);

		return 1;
	}

	Process = OpenProcess(
		PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_VM_OPERATION | PROCESS_CREATE_THREAD | PROCESS_SET_INFORMATION | PROCESS_QUERY_INFORMATION,
		FALSE,
		strtoul(av[1], 0, 0));

	if (!Process)
	{
		wprintf(L"OpenProcess fails (%lu).  Ensure that you provided a correct process id that you have full rights to.\n",
			GetLastError());

		return 1;
	}

	if (!InjectVmxPatch(
		Process,
		VmxPatchDll))
	{
		wprintf(L"Failed to inject code.  Ensure that you have full access to the process.\n");

		CloseHandle(
			Process
			);

		return 1;
	}

	CloseHandle(
		Process
		);

	wprintf(L"OK\n");

	return 0;
}
